#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
const options={
  key: fs_1.readFileSync('/home/admin/conf/web/ssl.cjhb.site.key'),
  cert: fs_1.readFileSync('/home/admin/conf/web/ssl.cjhb.site.crt')
};
var http_1 = require("https");
var WorkerPool_1 = require("./WorkerPool");
var pool = new WorkerPool_1.WorkerPool(4);
pool.onmessage = (event) => {
    console.error(`Received message from worker: ${event}`);
};
pool.onmessageerror = (event) => {
    console.error(`Error receiving message from worker: ${event}`);
};
function runWorker(code,engine) {
    return pool.work({code:code,engine:engine});
}
function getTimestamp() {
    return new Date().toISOString().replace('T', ' ').substring(0, 19);
}
function serve() {
    if (!fs_1.existsSync('temp')) {
        fs_1.mkdirSync('temp');
    }
    var server = http_1.createServer(options,function (request, response) {
            var url = new URL('http://cjhb.site' + request.url);
            var code = url.searchParams.get('tex');
        if (code) {
            var engine = url.searchParams.get('engine');
            if(!engine||engine=='pdflatex'||engine=='xelatex'||engine=='lualatex'||engine=='mpost'||engine=='gnuplot'||engine=='ps'){
                if(!engine){engine='pdflatex'};
              response.statusCode = 200;
                console.log("[" + getTimestamp() + "] Accepted.");
                var start_1 = new Date().valueOf();
                runWorker(code,engine).then(function (result) {
                    response.statusCode = 200;
                    if(!result.svg){response.setHeader("Content-type","text/plain");response.end(result.log)}else{response.setHeader("Content-type","image/svg+xml");response.end(result.svg);};console.log('log:'+result.log);
                    console.log("[" + getTimestamp() + "] Resolved (" + (new Date().valueOf() - start_1) + " ms)");
                });
            }
        }
    });
    server.listen(3000);
}
serve();
