"use strict";
var svg,log;
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var worker_threads_1 = require("worker_threads");
var md5_1 = __importDefault(require("md5"));
var rimraf_1 = __importDefault(require("rimraf"));
worker_threads_1.parentPort === null || worker_threads_1.parentPort === void 0 ? void 0 : worker_threads_1.parentPort.on('message', function (value) {
    var _a;
    try {
        worker_threads_1.parentPort === null || worker_threads_1.parentPort === void 0 ? void 0 : worker_threads_1.parentPort.postMessage(work(value));
    }
    catch (_b) {
        worker_threads_1.parentPort === null || worker_threads_1.parentPort === void 0 ? void 0 : worker_threads_1.parentPort.postMessage({
            taskId: (_a = value.taskId) !== null && _a !== void 0 ? _a : 0,
            svg: '',log:log
        });
    }
});

function work(data) {
    var _a, _b, _c, _d;
    var child_process_1=require('child_process');
    if (data.expiresAt && new Date().getTime() > data.expiresAt) {
        return {
            taskId: (_a = data.taskId) !== null && _a !== void 0 ? _a : 0,
            svg: '',log:log
        };
    }
    var tempDir = 'temp/t' + data.taskId;
    svg = '';
    try {
            // if hash exists, return it
            var now = new Date();
            var today = new Date(now.valueOf() - 14400000).toISOString().split('T')[0];
            if (!fs_1.existsSync('temp/' + today)) {
                fs_1.mkdirSync('temp/' + today);
                var toDelete = new Date(now.valueOf() - 14400000 - 86400000 * 30).toISOString().split('T')[0];
                if (fs_1.existsSync('temp/' + toDelete)){
                rimraf_1.default('temp/' + toDelete, function () { });
                }
            }
            var hash = md5_1.default(data.code);
            if (fs_1.existsSync("temp/" + today + "/" + hash + ".svg")) {
                svg=fs_1.readFileSync("temp/" + today+ "/" + hash + ".svg").toString();
                return {
                    taskId: (_b = data.taskId) !== null && _b !== void 0 ? _b : 0,
                    svg: svg, log:''
                };
            }
            for (var day = 1; day < 30; day++) {
                var date = new Date(now.valueOf() - 14400000 - 86400000 * day).toISOString().split('T')[0];
                if (fs_1.existsSync("temp/" + date + "/" + hash + ".svg")) {
                    fs_1.copyFile("temp/" + date + "/" + hash + ".svg", "temp/" + today + "/" + hash + ".svg", function () { });
                    svg=fs_1.readFileSync("temp/" + date+ "/" + hash + ".svg").toString();
                    return {
                        taskId: (_c = data.taskId) !== null && _c !== void 0 ? _c : 0,
                        svg: svg, log:''
                    };
                }
            }
        // do work
        if (!fs_1.existsSync(tempDir))
            fs_1.mkdirSync(tempDir);
    switch(data.engine){
        case "ps":
            var request = require('request');
            request.post(
                {url:'http://cjhb.site/ps/index.php',
                form:{code:data.code}},
                function (error, response, body) {
                    if (!error && response.statusCode == 200) {
			if(response.headers['content-type'].substring(0,10)=='text/plain'){
				svg = ''; log = body;
			}else{
				svg = body; log = '';
				fs_1.writeFileSync("temp/" + today + "/" + hash + '.svg',svg);
			}
                    }
                }
            );
            break;
        case "gnuplot":
            child_process_1.execSync('gnuplot -',{shell: "/bin/bash",input:"set encoding utf8;set term svg;set output "+tempDir+"'temp.svg';"+data.code});
            fs_1.copyFileSync(tempDir + "/temp.svg", "temp/" + today + "/" + hash + '.svg');
            if(fs_1.existsSync(tempDir + '/temp.log')){
                log = fs_1.readFileSync(tempDir + '/temp.log').toString();
            }
            svg = fs_1.readFileSync(tempDir + '/temp.svg').toString();
            break;
        case "mpost":
            fs_1.writeFileSync(tempDir + '/temp.mp', 'prologues := 3;\noutputformat :="svg";\nbeginfig(1);\n'+data.code+'\nendfig;\nend');
            child_process_1.execSync('cd '+tempDir+';mpost temp.mp',{shell: "/bin/bash"});
            fs_1.copyFileSync(tempDir+'/temp.1', "temp/" + today + "/" + hash + '.svg');
            if(fs_1.existsSync(tempDir + '/temp.log')){
                log = fs_1.readFileSync(tempDir + '/temp.log').toString();
            }
            svg = fs_1.readFileSync(tempDir + '/temp.1').toString();
            break;
        default:
            if(data.engine=="xelatex"){
                var cmd1=data.engine+'  -output-driver="xdvipdfmx -i dvipdfmx-unsafe.cfg -q -E" -output-directory='+tempDir+' --';}
            else{
                var cmd1=data.engine+' -output-directory='+tempDir+' --';
            }
            console.log(cmd1);
            child_process_1.execSync(cmd1,{shell: "/bin/bash",input:data.code});
            if(fs_1.existsSync(tempDir + '/texput.log')){
                log = fs_1.readFileSync(tempDir + '/texput.log').toString();
            }
            if (fs_1.existsSync(tempDir + '/texput.pdf')) {
                var cmd2='pdf2svg '+tempDir+'/texput.pdf '+tempDir+'/texput.svg';
                child_process_1.execSync(cmd2,{shell: "/bin/bash"});
                console.log(cmd2);
                svg = fs_1.readFileSync(tempDir + '/texput.svg').toString();
                fs_1.copyFileSync(tempDir + "/texput.svg", "temp/" + today + "/" + hash + '.svg');
            }
    }
}
    catch (_e) {console.log(_e);log+=_e;};
    if(log=='')rimraf_1.default(tempDir, function () {});
    return {
            taskId: (_d = data.taskId) !== null && _d !== void 0 ? _d : 0,
            svg: svg,log:log
    }
}